#define pinA 8
#define pinB 9
#define pinC 10
#define pinD 11

#define LED_NUM 12
#define UNUSED 100

int matrix[LED_NUM][4] = {
  {HIGH, LOW, UNUSED, UNUSED},//0
  {LOW, HIGH, UNUSED, UNUSED},//1
  {UNUSED, HIGH, LOW, UNUSED},//2
  {UNUSED, LOW, HIGH, UNUSED},//3
  {UNUSED, UNUSED, HIGH, LOW},//4
  {UNUSED, UNUSED, LOW, HIGH},//5
  {HIGH, UNUSED, LOW, UNUSED},//6
  {LOW, UNUSED, HIGH, UNUSED},//7
  {UNUSED, HIGH, UNUSED, LOW},//8
  {UNUSED, LOW, UNUSED, HIGH},//9
  {HIGH, UNUSED, UNUSED, LOW},//10
  {LOW, UNUSED, UNUSED, HIGH} //11
};

void lightOn( int led ) {
  clearAll();
  setPinMode(pinA, matrix[led][0]);
  setPinMode(pinB, matrix[led][1]);
  setPinMode(pinC, matrix[led][2]);
  setPinMode(pinD, matrix[led][3]);
} 

void clearAll() {
  pinMode(pinA, INPUT);
  pinMode(pinB, INPUT);
  pinMode(pinC, INPUT);
  pinMode(pinD, INPUT);
}

void setPinMode(int pin, int mode) {
  switch(mode) {
    case UNUSED:
      pinMode(pin, INPUT);
      break;
    case LOW:
      pinMode(pin, OUTPUT);
      digitalWrite(pin, LOW);
      break;
    case HIGH:
      pinMode(pin, OUTPUT);
      digitalWrite(pin, HIGH);
      break;
  }
}

void setup() {}

void loop() {
  for(int i=0; i<LED_NUM; i++) {
     lightOn(i);
      delay(500);
  }
}
