#include <MyRealTimeClock.h>                         


MyRealTimeClock myRTC(6, 7, 8);

void setup()  {      
  Serial.begin(9600);
  Serial.println("To set the timer, type year month day hour minute second dayOfWeek and then press enter");
}


void loop()  {                                                                                            
  checkCmdSetting();
  printDateTime();   
  Serial.println();                                                         
  delay(3000);                                                                    
}       

void checkCmdSetting() {
  while (Serial.available() > 0) {
    int year = Serial.parseInt();
    int month = Serial.parseInt();
    int day = Serial.parseInt();
    int hour = Serial.parseInt();
    int minute = Serial.parseInt();
    int second = Serial.parseInt();
    int dayofweek = Serial.parseInt();

    if (Serial.read() == '\n') {
      myRTC.setDS1302Time(second, minute, hour, dayofweek, day, month, year);
      Serial.print("DateTime set to: ");
      printDateTime();
      Serial.println();
    }
  }
}

#define countof(a) (sizeof(a) / sizeof(a[0]))

void printDateTime() {
  char datestring[20];
  myRTC.updateTime();   
  snprintf_P(datestring, 
            countof(datestring),
            PSTR("%04u/%02u/%02u %02u:%02u:%02u"),
            myRTC.year,
            myRTC.month,
            myRTC.dayofmonth,
            myRTC.hours,
            myRTC.minutes,
            myRTC.seconds);
    Serial.print(datestring);
}

     
