#include <SoftwareSerial.h>
#include <DFPlayer_Mini_Mp3.h>

#define pinA 6
#define pinB 7
#define pinSW 5

SoftwareSerial mySerial(10, 11);

int aState;
int aLastState;  
int volumn;
int current;
int total;

void setup () {
  pinMode(pinA, INPUT);
  pinMode(pinB, INPUT);
  pinMode(pinSW, INPUT);
  aLastState = digitalRead(pinA);
  volumn = 20;
  current = 1;
  total = 5;

  
  Serial.begin (9600);
  mySerial.begin (9600);
  mp3_set_serial (mySerial);  
  delay(1); 
  mp3_set_volume (volumn);
  mp3_play(current);
}


//
void loop () {   
  if (digitalRead(pinSW) == LOW) {
    current = current % total;
    mp3_play(current+1);
    current++;
    Serial.print("current:");
    Serial.println(current);
    delay(2000);
  }
   
  aState = digitalRead(pinA); 
  if (aState != aLastState){
    if (digitalRead(pinB) != aState) { 
      volumn = volumn - 1;
    } else {
      volumn = volumn + 1;
    }
    volumn = constrain(volumn, 0, 100);
    Serial.print("volumn");
    Serial.println(volumn);
    mp3_set_volume (volumn);
  }
  aLastState = aState;
}

/*
   mp3_play ();   //start play
   mp3_play (5);  //play "mp3/0005.mp3"
   mp3_next ();   //play next 
   mp3_prev ();   //play previous
   mp3_set_volume (uint16_t volume);  //0~30
   mp3_set_EQ (); //0~5
   mp3_pause ();
   mp3_stop ();
   void mp3_get_state ();   //send get state command
   void mp3_get_volume (); 
   void mp3_get_u_sum (); 
   void mp3_get_tf_sum (); 
   void mp3_get_flash_sum (); 
   void mp3_get_tf_current (); 
   void mp3_get_u_current (); 
   void mp3_get_flash_current (); 
   void mp3_single_loop (boolean state);  //set single loop 
   void mp3_DAC (boolean state); 
   void mp3_random_play (); 
 */
