

// pins for the LEDs:
const int redPin = 9;
const int greenPin = 10;
const int bluePin = 11;

int val = 0;
int colorChoice = 0;
int s;
int sLast;
int pinA = 6;
int pinB = 7;
int pinSw = 5;

void setup() {
  // initialize serial:
  Serial.begin(9600);
  // make the pins outputs:
  pinMode(redPin, OUTPUT);
  pinMode(greenPin, OUTPUT);
  pinMode(bluePin, OUTPUT);

  pinMode(pinSw, INPUT);
  pinMode(pinA, INPUT);
  pinMode(pinB, INPUT);
  sLast = digitalRead(pinA);
}

void loop() {
  colorByCmd();
//  colorByRotary();
}

int red = 0;
int green = 0;
int blue = 0;

void colorByRotary() {
  checkSwitch();
  readRotary();
//  analogWriteColor();
  pwdColor();
}

void analogWriteColor() {
  analogWrite(redPin, red);
  analogWrite(greenPin, green);
  analogWrite(bluePin, blue);
}

int pwdLoop = 0;
void pwdColor() {
  pwdLoop++;
  if(pwdLoop > 255) {
    pwdLoop = 0;
  }
  digitalWrite(redPin, red>pwdLoop ? HIGH : LOW);
  digitalWrite(greenPin, green>pwdLoop ? HIGH : LOW);
  digitalWrite(bluePin, blue>pwdLoop ? HIGH : LOW);
}


void checkSwitch() {
  if (digitalRead(pinSw) == LOW) {
    colorChoice++;
    if (colorChoice > 2) {
      colorChoice = 0;
    }
    switch(colorChoice) {
      case 0:
        val = red;
        break;
      case 1:
        val = green;
        break;
      case 2:
        val = blue;
        break;
    }
    delay(1000);
  }
}

void readRotary() {
  s = digitalRead(pinA);
  if (s != sLast) {
    if (digitalRead(pinB) != s) {
      val++;
    } else {
      val--;
    }
    sLast = s;

    val = constrain(val, 0, 255);
    switch(colorChoice) {
      case 0:
        red = val;
        break;
      case 1:
        green = val;
        break;
      case 2:
        blue = val;
        break;
    }
    Serial.println(val);
  }
}


void colorByCmd() {
  while (Serial.available() > 0) {
    red = Serial.parseInt();
    green = Serial.parseInt();
    blue = Serial.parseInt();

    if (Serial.read() == '\n') {
      red = constrain(red, 0, 255);
      green = constrain(green, 0, 255);
      blue = constrain(blue, 0, 255);

       //analogWriteColor();
      Serial.print(red);
      Serial.print(",\t");
      Serial.print(green);
      Serial.print(",\t");
      Serial.println(blue);
    }
  }

  pwdColor();
}
