

// pins for the LEDs:
const int pinNA = 2; // not pwm pin, use analogwriting
const int pinPA = 5; //pwm pin, use analogwriting
const int pinPP = 9; //pwm pin, use pwmWriting
const int pinNP = 13; //not pwm pin, use pwmwritingß 

int brightness = 50;
int interval = 0;
int pwdLoop = 0;

void setup() {
  // initialize serial:
  Serial.begin(9600);
  pinMode(pinNA, OUTPUT);
  pinMode(pinPA, OUTPUT);
  pinMode(pinPP, OUTPUT);
  pinMode(pinNP, OUTPUT);

  // first, check all lights are fine
  digitalWrite(pinNA, HIGH);
  digitalWrite(pinPA, HIGH);
  digitalWrite(pinPP, HIGH);
  digitalWrite(pinNP, HIGH);

  delay(5000);

  analogWrite(pinPA, brightness);
  analogWrite(pinNA, brightness);
}

void loop() {
  readCommand();
  pwdLoop++;
  if(pwdLoop > 255) {
    pwdLoop = 0;
  }
  digitalWrite(pinNP, brightness>pwdLoop ? HIGH : LOW);
  digitalWrite(pinPP, brightness>pwdLoop ? HIGH : LOW);

  if(interval>0){
    delay(interval);
  }
}

void readCommand(){
  while (Serial.available() > 0) {
    brightness = Serial.parseInt();
    interval = Serial.parseInt();

    if (Serial.read() == '\n') {
      Serial.print("change brightness to: ");
      Serial.print(brightness);
      Serial.print("change interval to: ");
      Serial.println(interval);
      analogWrite(pinPA, brightness);
      analogWrite(pinNA, brightness);
    }
  }
}
